// StorageCardReadOutDlg.cpp : Implementierungsdatei
//

#include "stdafx.h"
#include "StorageCardReadOut.h"
#include "StorageCardReadOutDlg.h"
#include ".\storagecardreadoutdlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CAboutDlg-Dialogfeld fr Anwendungsbefehl 'Info'

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialogfelddaten
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV-Untersttzung

// Implementierung
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


// CStorageCardReadOutDlg Dialogfeld



CStorageCardReadOutDlg::CStorageCardReadOutDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CStorageCardReadOutDlg::IDD, pParent)
	, m_edit_path(_T("C:\\Test.dat"))
	, m_edit_status(_T("Status"))
	, m_edit_startsector(0)
	, m_edit_endsector(1)
	, m_check_copysectors(FALSE)
	, m_check_copyall(TRUE)
	, m_radio_cardsize(0)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CStorageCardReadOutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Text(pDX, IDC_EDIT_PATH, m_edit_path);
	DDX_Text(pDX, IDC_EDIT_STATUS, m_edit_status);
	DDX_Control(pDX, IDC_COMBO_DRIVE, m_combo_device);
	DDX_Control(pDX, IDC_PROGRESS_STATUS, m_progress_status);
	DDX_Text(pDX, IDC_EDIT_STARTSECTOR, m_edit_startsector);
	DDX_Text(pDX, IDC_EDIT_ENDSECTOR, m_edit_endsector);
	DDX_Check(pDX, IDC_CHECK_COPYSECTORS, m_check_copysectors);
	DDX_Check(pDX, IDC_CHECK_COPYALL, m_check_copyall);
}

BEGIN_MESSAGE_MAP(CStorageCardReadOutDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_BUTTON_SELECT_PATH, OnBnClickedButtonSelectPath)
	ON_BN_CLICKED(IDC_BUTTON_GET_DATA, OnBnClickedButtonGetData)
	ON_BN_CLICKED(IDC_RADIO01, OnBnClickedRadio01)
	ON_BN_CLICKED(IDC_RADIO02, OnBnClickedRadio02)
	ON_BN_CLICKED(IDC_RADIO03, OnBnClickedRadio03)
	ON_BN_CLICKED(IDC_RADIO04, OnBnClickedRadio04)
	ON_BN_CLICKED(IDC_RADIO05, OnBnClickedRadio05)
	ON_BN_CLICKED(IDC_RADIO06, OnBnClickedRadio06)
	ON_BN_CLICKED(IDC_RADIO07, OnBnClickedRadio07)
	ON_BN_CLICKED(IDC_RADIO08, OnBnClickedRadio08)
	ON_BN_CLICKED(IDC_CHECK_COPYSECTORS, OnBnClickedCheckCopysectors)
	ON_BN_CLICKED(IDC_CHECK_COPYALL, OnBnClickedCheckCopyall)
END_MESSAGE_MAP()


// CStorageCardReadOutDlg Meldungshandler

BOOL CStorageCardReadOutDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Hinzufgen des Menbefehls "Info..." zum Systemmen.

	// IDM_ABOUTBOX muss sich im Bereich der Systembefehle befinden.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Symbol fr dieses Dialogfeld festlegen. Wird automatisch erledigt
	//  wenn das Hauptfenster der Anwendung kein Dialogfeld ist
	SetIcon(m_hIcon, TRUE);			// Groes Symbol verwenden
	SetIcon(m_hIcon, FALSE);		// Kleines Symbol verwenden

	// TODO: Hier zustzliche Initialisierung einfgen
	m_combo_device.SetCurSel(8);
	//m_radio_cardsize.CheckRadioButton(IDC_RADIO01,IDC_RADIO08,IDC_RADIO02);
	UpdateData(FALSE);

	return TRUE;  // Geben Sie TRUE zurck, auer ein Steuerelement soll den Fokus erhalten
}

void CStorageCardReadOutDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// Wenn Sie dem Dialogfeld eine Schaltflche "Minimieren" hinzufgen, bentigen Sie 
//  den nachstehenden Code, um das Symbol zu zeichnen. Fr MFC-Anwendungen, die das 
//  Dokument/Ansicht-Modell verwenden, wird dies automatisch ausgefhrt.

void CStorageCardReadOutDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // Gertekontext zum Zeichnen

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Symbol in Clientrechteck zentrieren
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Symbol zeichnen
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// Die System ruft diese Funktion auf, um den Cursor abzufragen, der angezeigt wird, whrend der Benutzer
//  das minimierte Fenster mit der Maus zieht.
HCURSOR CStorageCardReadOutDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

void CStorageCardReadOutDlg::OnBnClickedButtonSelectPath()
{
	OPENFILENAME ofn;       // common dialog box structure
	char szFile[260];       // buffer for file name

	ZeroMemory(&ofn, sizeof(ofn));
	ofn.lStructSize = sizeof(ofn);
	ofn.lpstrFile = szFile;
	ofn.lpstrFile[0] = '\0';
	ofn.nMaxFile = sizeof(szFile);
	ofn.lpstrFilter = "All\0*.*\0Text\0*.txt\0Data\0*.dat\0";
	ofn.nFilterIndex = 1;
	ofn.lpstrFileTitle = NULL;
	ofn.nMaxFileTitle = 0;
	ofn.lpstrInitialDir = NULL;
	ofn.Flags = OFN_PATHMUSTEXIST | OFN_FILEMUSTEXIST;
	
	if (GetSaveFileName(&ofn) == TRUE)
		m_edit_path = ofn.lpstrFile;
	else
		m_edit_path = "Enter or select valid path!";
	UpdateData(FALSE);
}

void CStorageCardReadOutDlg::OnBnClickedButtonGetData()
{
	THREADSTRUCT *_param = new THREADSTRUCT;
    _param->_this = this;
	AfxBeginThread(WorkerThread,_param,THREAD_PRIORITY_NORMAL,0,0,NULL);
}

void CStorageCardReadOutDlg::OnBnClickedRadio01()
{
	UpdateData(TRUE); m_radio_cardsize = 32; UpdateData(FALSE);
}

void CStorageCardReadOutDlg::OnBnClickedRadio02()
{
	UpdateData(TRUE); m_radio_cardsize = 64; UpdateData(FALSE);
}

void CStorageCardReadOutDlg::OnBnClickedRadio03()
{
	UpdateData(TRUE); m_radio_cardsize = 128; UpdateData(FALSE);
}

void CStorageCardReadOutDlg::OnBnClickedRadio04()
{
	UpdateData(TRUE); m_radio_cardsize = 256; UpdateData(FALSE);
}

void CStorageCardReadOutDlg::OnBnClickedRadio05()
{
	UpdateData(TRUE); m_radio_cardsize = 512; UpdateData(FALSE);
}

void CStorageCardReadOutDlg::OnBnClickedRadio06()
{
	UpdateData(TRUE); m_radio_cardsize = 1024; UpdateData(FALSE);
}

void CStorageCardReadOutDlg::OnBnClickedRadio07()
{
	UpdateData(TRUE); m_radio_cardsize = 2048; UpdateData(FALSE);
}

void CStorageCardReadOutDlg::OnBnClickedRadio08()
{
	UpdateData(TRUE); m_radio_cardsize = 4096; UpdateData(FALSE);
}

void CStorageCardReadOutDlg::OnBnClickedCheckCopysectors()
{
	UpdateData(TRUE);
	if (m_check_copysectors)
		if (m_check_copyall)
			m_check_copyall = FALSE;
	UpdateData(FALSE);
}

void CStorageCardReadOutDlg::OnBnClickedCheckCopyall()
{
	UpdateData(TRUE);
	if (m_check_copyall)
		if (m_check_copysectors)
			m_check_copysectors = FALSE;
	UpdateData(FALSE);
}

UINT CStorageCardReadOutDlg::WorkerThread(LPVOID param)
{
	THREADSTRUCT*    ts = (THREADSTRUCT*)param;

	ts->_this->UpdateData(TRUE);
	

	CFile file;										//file on local system
	HANDLE hDevice;									//handle to access card
	int Position = ts->_this->m_combo_device.GetCurSel();		//get device number
	CString DeviceSelection;
	ts->_this->m_combo_device.GetLBText(Position, DeviceSelection);
	CString path = "\\\\.\\" + DeviceSelection + ":";
	int SectorsToReadOnce = 0;
	char buffer[1024*512];
	DWORD bytesread = 0;
	DWORD SectorsToRead = 0;

	if (!file.Open (ts->_this->m_edit_path, CFile::modeWrite | CFile::modeCreate))
	{
		ts->_this->m_edit_status = "Could not open file!"; 
		ts->_this->UpdateData(FALSE);
		return 1;
	}
	
	hDevice = CreateFile(path,		  // drive to open
                    GENERIC_READ,     // read access to the drive
                    FILE_SHARE_READ,  // share mode 
                    NULL,             // default security attributes
                    OPEN_EXISTING,    // disposition
                    0,                // file attributes
                    NULL);            // do not copy file attributes

	if (hDevice == INVALID_HANDLE_VALUE) // cannot open the drive
	{
		ts->_this->m_edit_status = "Wrong Device!";
		ts->_this->UpdateData(FALSE);
		return 1;
	}

	ts->_this->m_edit_status = "Reading Device!";
	ts->_this->UpdateData(FALSE);
	
	if (ts->_this->m_check_copyall)
	{
		SectorsToReadOnce = 1024;		//fast version
		SectorsToRead = ts->_this->m_radio_cardsize * 1024 * 2;
	}
	else
	{
		SectorsToReadOnce = 1;			//slow version
		SectorsToRead = ts->_this->m_edit_endsector - ts->_this->m_edit_startsector;
		DWORD dwPtr = SetFilePointer(hDevice,					//handle to drive
									(ts->_this->m_edit_startsector*512),	//sector
									NULL,						//
									FILE_BEGIN);				//method
		
		if (dwPtr == INVALID_SET_FILE_POINTER)					// Test for failure
		{ 
			DWORD dwError = GetLastError(); 
			CloseHandle(hDevice);
			file.Close();
			ts->_this->m_edit_status = "Set file pointer failed!";
			ts->_this->UpdateData(FALSE);
			return 1;
		}
	}

	if (SectorsToRead < 1)
	{
		CloseHandle(hDevice);
		file.Close();
		ts->_this->m_edit_status = "Reading complete!";
		ts->_this->UpdateData(FALSE);
		return 1;
	}

	ts->_this->m_progress_status.SetRange (0, (short)(SectorsToRead/SectorsToReadOnce));

	for (unsigned int i=0; i<(SectorsToRead/SectorsToReadOnce); i++)
	{
		if (!ReadFile(hDevice, (LPVOID) buffer, SectorsToReadOnce*512, &bytesread, NULL))
		{
			DWORD dwError = GetLastError(); 
			ts->_this->m_edit_status = "Device read failed!";
			ts->_this->UpdateData(FALSE);
			CloseHandle(hDevice);
			file.Close();
			return 1;
		}
		
		file.Write(buffer, SectorsToReadOnce*512);

		if (ts->_this->m_check_copyall)
		{
			DWORD dwPtr = SetFilePointer(hDevice,					//handle to drive
										(i*SectorsToReadOnce*512),	//sector
										NULL,						//
										FILE_BEGIN);				//method
			
			if (dwPtr == INVALID_SET_FILE_POINTER)					// Test for failure
			{ 
				DWORD dwError = GetLastError(); 
				CloseHandle(hDevice);
				file.Close();
				ts->_this->m_edit_status = "Set file pointer failed!";
				ts->_this->UpdateData(FALSE);
				return 1;
			}
		}
		else
		{
			DWORD dwPtr = SetFilePointer(hDevice,					//handle to drive
										(i*SectorsToReadOnce+ts->_this->m_edit_startsector)*512,
										NULL,						//
										FILE_BEGIN);				//method
			
			if (dwPtr == INVALID_SET_FILE_POINTER)					// Test for failure
			{ 
				DWORD dwError = GetLastError(); 
				CloseHandle(hDevice);
				file.Close();
				ts->_this->m_edit_status = "Set file pointer failed!";
				ts->_this->UpdateData(FALSE);
				return 1;
			}
		}

		ts->_this->m_progress_status.SetPos (i+1);
	}

	CloseHandle(hDevice);
	file.Close();
	ts->_this->m_edit_status = "Reading complete!";
	ts->_this->UpdateData(FALSE);
	return 0;
}
