// StorageCardReadOutDlg.h : Headerdatei
//

#pragma once

#include <winioctl.h>
#include "afxwin.h"
#include "afxcmn.h"

// CStorageCardReadOutDlg Dialogfeld
class CStorageCardReadOutDlg : public CDialog
{
// Konstruktion
public:
	CStorageCardReadOutDlg(CWnd* pParent = NULL);	// Standardkonstruktor

// Dialogfelddaten
	enum { IDD = IDD_STORAGECARDREADOUT_DIALOG };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV-Untersttzung


// Implementierung
protected:
	HICON m_hIcon;

	// Generierte Funktionen fr die Meldungstabellen
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	DECLARE_MESSAGE_MAP()
public:
	afx_msg void OnBnClickedButtonSelectPath();
	CString m_edit_path;
	CString m_edit_status;
	afx_msg void OnBnClickedButtonGetData();
	CComboBox m_combo_device;
	CProgressCtrl m_progress_status;
	UINT m_edit_startsector;
	UINT m_edit_endsector;
	BOOL m_check_copysectors;
	BOOL m_check_copyall;
	afx_msg void OnBnClickedRadio01();
	afx_msg void OnBnClickedRadio02();
	afx_msg void OnBnClickedRadio03();
	afx_msg void OnBnClickedRadio04();
	afx_msg void OnBnClickedRadio05();
	afx_msg void OnBnClickedRadio06();
	afx_msg void OnBnClickedRadio07();
	afx_msg void OnBnClickedRadio08();
	int m_radio_cardsize;
	afx_msg void OnBnClickedCheckCopysectors();
	afx_msg void OnBnClickedCheckCopyall();
	static UINT WorkerThread(LPVOID param);
};

typedef struct THREADSTRUCT
{
	CStorageCardReadOutDlg *_this;
} THREADSTRUCT;